Bug 1967204 - pygrib fails to build in Fedora 35+: Broken RPATH will fail rpmbuild
Summary: pygrib fails to build in Fedora 35+: Broken RPATH will fail rpmbuild
Keywords:
Status: CLOSED WORKSFORME
Alias: None
Product: Fedora
Classification: Fedora
Component: pygrib
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Jos de Kloe
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
: 1968866 (view as bug list)
Depends On: 1968870
Blocks: F35FTBFS F35FailsToInstall PYTHON3.10
TreeView+ depends on / blocked
 
Reported: 2021-06-02 15:39 UTC by Tomáš Hrnčiar
Modified: 2021-06-17 15:33 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-06-17 15:33:42 UTC
Type: Bug


Attachments (Terms of Use)

Description Tomáš Hrnčiar 2021-06-02 15:39:42 UTC
pygrib fails to build with Python 3.10.0b1.

https://fedoraproject.org/wiki/Changes/Broken_RPATH_will_fail_rpmbuild 

Related section in packaging guidelines.
https://docs.fedoraproject.org/en-US/packaging-guidelines/#_beware_of_rpath

+ /usr/lib/rpm/check-rpaths
*******************************************************************************
*
* WARNING: 'check-rpaths' detected a broken RPATH OR RUNPATH and will cause
*          'rpmbuild' to fail. To ignore these errors, you can set the
*          '$QA_RPATHS' environment variable which is a bitmask allowing the
*          values below. The current value of QA_RPATHS is 0x0000.
*
*    0x0001 ... standard RPATHs (e.g. /usr/lib); such RPATHs are a minor
*               issue but are introducing redundant searchpaths without
*               providing a benefit. They can also cause errors in multilib
*               environments.
*    0x0002 ... invalid RPATHs; these are RPATHs which are neither absolute
*               nor relative filenames and can therefore be a SECURITY risk
*    0x0004 ... insecure RPATHs; these are relative RPATHs which are a
*               SECURITY risk
*    0x0008 ... the special '$ORIGIN' RPATHs are appearing after other
*               RPATHs; this is just a minor issue but usually unwanted
*    0x0010 ... the RPATH is empty; there is no reason for such RPATHs
*               and they cause unneeded work while loading libraries
*    0x0020 ... an RPATH references '..' of an absolute path; this will break
*               the functionality when the path before '..' is a symlink
*          
*
* Examples:
* - to ignore standard and empty RPATHs, execute 'rpmbuild' like
*   $ QA_RPATHS=$(( 0x0001|0x0010 )) rpmbuild my-package.src.rpm
* - to check existing files, set $RPM_BUILD_ROOT and execute check-rpaths like
*   $ RPM_BUILD_ROOT=<top-dir> /usr/lib/rpm/check-rpaths
*  
*******************************************************************************
ERROR   0001: file '/usr/lib64/python3.10/site-packages/pygrib/_pygrib.cpython-310-x86_64-linux-gnu.so' contains a standard runpath '/usr/lib' in [/usr/lib]

For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.10/fedora-rawhide-x86_64/02217935-pygrib/

For all our attempts to build pygrib with Python 3.10, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/package/pygrib/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.10:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/

Let us know here if you have any questions.

Python 3.10 will be included in Fedora 35. To make that update smoother, we're building Fedora packages with early pre-releases of Python 3.10.
A build failure prevents us from testing all dependent packages (transitive [Build]Requires), so if this package is required a lot, it's important for us to get it fixed soon.
We'd appreciate help from the people who know this package best, but if you don't want to work on this now, let us know so we can try to work around it on our side.

Comment 1 Jos de Kloe 2021-06-03 19:46:27 UTC
Seems to me this is something added by cython. There is no hint whatsoever in the pygrib source code that would explain that rpath is explicitly added.
Are there other cython build packages with the same issue?

Comment 2 Miro Hrončok 2021-06-03 20:25:50 UTC
setup.py has:

ext_modules = [
    setuptools.Extension(
        "pygrib._pygrib",
        ["pygrib/_pygrib.pyx"],
        include_dirs=incdirs,
        library_dirs=libdirs,
        runtime_library_dirs=libdirs,
        libraries=["eccodes"],
    )
]

I think "runtime_library_dirs" is rpath.

Comment 3 Jos de Kloe 2021-06-03 20:29:39 UTC
ok thanks, I'll patch the setup.py file to see if that fixes it.

Comment 4 Jos de Kloe 2021-06-04 12:36:21 UTC
Problem has been patched now, see commit 44c3cb497c9c0f5e09e957505a5166d1b4d473be.
It builds now in a local mock copr build for fedora-rawhide-python310 and also builds correctly in regular rawhide.

Comment 5 Miro Hrončok 2021-06-04 20:15:31 UTC
This is a mass-posted update. Sorry if it is not 100% accurate to this bugzilla.


The Python 3.10 rebuild is in progress in a Koji side tag. If you manage to fix the problem, please commit the fix in the rawhide branch, but don't build the package in regular rawhide.

You can either build the package in the side tag, with:

    $ fedpkg build --target=f35-python

Or you can the build and we will eventually build it for you.

Note that the rebuild is still in progress, so not all (build) dependencies of this package might be available right away.

Thanks.

See also https://fedoraproject.org/wiki/Changes/Python3.10

If you have general questions about the rebuild, please use this mailing list thread: https://lists.fedoraproject.org/archives/list/devel@lists.fedoraproject.org/thread/G47SGOYIQLRDTWGOSLSWERZSSHXDEDH5/

Comment 6 Miro Hrončok 2021-06-07 22:59:56 UTC
The f35-python side tag has been merged to Rawhide. From now on, build as you would normally build.

Comment 7 Miro Hrončok 2021-06-08 11:19:59 UTC
*** Bug 1968866 has been marked as a duplicate of this bug. ***


Note You need to log in before you can comment on or make changes to this bug.